SystemOrganization addCategory: #'ObjectSheet-Core'!
SystemOrganization addCategory: #'ObjectSheet-Morph'!
SystemOrganization addCategory: #'ObjectSheet-Morph-cell'!
SystemOrganization addCategory: #'ObjectSheet-Morphic'!

!True methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:04'!
themeSmallIcon
	^ThemeIcons smallOkIcon! !

!Text methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:03'!
objectSheetCellMorphContents
	^self! !

!Text methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:42'!
objectSheetCellMorphWidthIn: anObjectSheetMorph
	^(anObjectSheetMorph defaultCellFont widthOfStringOrText: self) + 20! !

!Text methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:04'!
objectSheetCellMorphWithCellBounds: aRectangle  in:  anObjectSheetMorph
	^OSTextCellMorph new
		bounds: aRectangle;
		font: anObjectSheetMorph defaultCellFont;
		contents: self objectSheetCellMorphContents! !

!False methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:03'!
themeSmallIcon
	^ThemeIcons smallCancelIcon! !

!Morph methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:03'!
objectSheetCellMorphContents
	^self! !

!Morph methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:22'!
objectSheetCellMorphWidthIn: anObjectSheetMorph
	^self width! !

!Morph methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:04'!
objectSheetCellMorphWithCellBounds: aRectangle  in:  anObjectSheetMorph
	^OSMorphCellMorph new
		bounds: aRectangle;
		contents: self objectSheetCellMorphContents! !

Morph subclass: #OSCellMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

OSCellMorph subclass: #OSMorphCellMorph
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

!OSMorphCellMorph methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 12:19'!
contents: aMorph
	morph := aMorph.
	aMorph extent: (aMorph extent min: self extent).
	self addMorph: aMorph.
	morph center: self center.! !

!OSMorphCellMorph methodsFor: 'initialize' stamp: 'HwaJong 3/14/2013 11:19'!
initialize
	super initialize.
	self color: Color white.! !

OSCellMorph subclass: #OSTextCellMorph
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

OSTextCellMorph subclass: #OSHeaderCellMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph-cell'!

!OSHeaderCellMorph methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 11:10'!
contents: aString
	super contents: aString asText allBold! !

!OSHeaderCellMorph methodsFor: 'initialize' stamp: 'HwaJong 3/14/2013 11:08'!
initialize 
	super initialize.
	self color: (Color gray: 0.7).! !

!OSTextCellMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 14:11'!
contents: aString 
	labelMorph contents: aString.
	labelMorph center: self center.! !

!OSTextCellMorph methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 00:53'!
font: aStrikeFont 
	labelMorph font: aStrikeFont! !

!OSTextCellMorph methodsFor: 'initialize' stamp: 'HwaJong 3/14/2013 00:54'!
initialize
	super initialize.
	self color: Color white.
	labelMorph := LabelMorph new.
	self addMorph: labelMorph.
	labelMorph hResizing: #spaceFill.
	labelMorph vResizing: #spaceFill.! !

!Boolean methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:03'!
objectSheetCellMorphContents
	^(self themeSmallIcon) asMorph! !

!Boolean methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:20'!
objectSheetCellMorphWidthIn:  anObjectSheetMorph
	^self themeSmallIcon width! !

!Boolean methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 17:31'!
objectSheetCellMorphWithCellBounds: aRectangle in:  anObjectSheetMorph
	^OSMorphCellMorph new
		bounds: aRectangle;
		contents: (self objectSheetCellMorphContents)! !

Object subclass: #OSColumn
	instanceVariableNames: 'name aspect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Core'!

!OSColumn class methodsFor: 'instance creation' stamp: 'HwaJong 3/13/2013 19:47'!
rowHeader
	^self new 
		name: '';
		aspect: #name! !

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:06'!
aspect
	^ aspect! !

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:46'!
aspect: symbolOrBlock 
	aspect := symbolOrBlock! !

!OSColumn methodsFor: 'defaults' stamp: 'HwaJong 3/4/2013 10:45'!
defaultName

	"Return a default object for instance variable name."
	^'<no name>'! !

!OSColumn methodsFor: 'evaluating' stamp: 'HwaJong 3/14/2013 19:01'!
getAspectValueOf: anObject
	|op|
	op := [aspect value: anObject objectSheetObject ] .
	^op
		on: Error do: [:exp| 
			|button|
			button := SimpleButtonMorph new.
			button label: 'debug'.
			button color: (Color r: 1 g: 0.6 b: 0.6).
			button target: op.
			button actionSelector: #value.
			button]! !

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:45'!
name

	^name setDefault: #defaultName for: self withSetter: #name:! !

!OSColumn methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 19:47'!
name: aString
		
	name := aString! !

Object subclass: #OSRow
	instanceVariableNames: 'name object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Core'!

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:12'!
name
	^name! !

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:47'!
name: aString 
	name := aString! !

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:07'!
object
	^ object! !

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:47'!
object: anObject 
	object := anObject! !

!OSRow methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 18:06'!
objectSheetObject
	^self object! !

Object subclass: #OSUpdatingMethod
	instanceVariableNames: 'objectSheetMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

OSUpdatingMethod subclass: #OSNullUpdate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

!OSNullUpdate methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 15:46'!
updateObjectSheetMorphBy: aSymbol 
	"i do nothing"
	^self! !

OSUpdatingMethod subclass: #OSReceiveRowsToUpdate
	instanceVariableNames: 'updateSelector model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

!OSReceiveRowsToUpdate methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 17:43'!
model: anObject
	model := anObject! !

!OSReceiveRowsToUpdate methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 17:09'!
updateObjectSheetMorphBy: aSymbol 
	aSymbol = updateSelector 
		ifTrue: 
			[objectSheetMorph sheetModel rows: nil.
			(model perform: aSymbol) do: [:each| objectSheetMorph sheetModel addRowWithObject: each].
			objectSheetMorph updateCells]	! !

!OSReceiveRowsToUpdate methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:53'!
updateSelector: aSymbol 
	updateSelector := aSymbol ! !

OSUpdatingMethod subclass: #OSSelfUpdate
	instanceVariableNames: 'updateSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

!OSSelfUpdate methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 15:49'!
updateObjectSheetMorphBy: aSymbol 
	updateSelector = aSymbol
		ifTrue: [objectSheetMorph updateCells] ! !

!OSSelfUpdate methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:48'!
updateSelector
	^updateSelector! !

!OSSelfUpdate methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:48'!
updateSelector: aSymbol
	updateSelector := aSymbol! !

!OSUpdatingMethod class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 15:43'!
newForObjectSheetMorph: anObjectSheetMorph
	^self new objectSheetMorph: anObjectSheetMorph! !

!OSUpdatingMethod methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:50'!
objectSheetMorph: anObjectSheetMoprh
	objectSheetMorph := anObjectSheetMoprh.! !

!Object methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:03'!
objectSheetCellMorphContents
	^self printString! !

!Object methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/14/2013 17:24'!
objectSheetCellMorphWidthIn: anObjectSheetMorph
	^(anObjectSheetMorph defaultCellFont widthOfStringOrText: self asString) + 20! !

!Object methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 14:04'!
objectSheetCellMorphWithCellBounds: aRectangle  in:  anObjectSheetMorph
	^OSTextCellMorph new
		bounds: aRectangle;
		font: anObjectSheetMorph defaultCellFont;
		contents: self objectSheetCellMorphContents! !

!Object methodsFor: '*ObjectSheet' stamp: 'HwaJong 3/13/2013 18:07'!
objectSheetObject
	^self! !

Object subclass: #ObjectSheet
	instanceVariableNames: 'name columns rows cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Core'!

!ObjectSheet methodsFor: 'adding' stamp: 'HwaJong 3/4/2013 10:43'!
addColumn: aString aspect: blockOrSymbol
	self columns addLast: (OSColumn new name: aString; aspect: blockOrSymbol)! !

!ObjectSheet methodsFor: 'adding' stamp: 'HwaJong 4/3/2013 04:06'!
addColumnWithAspectSymbol: aSymbol
	self columns addLast: (OSColumn new name: aSymbol asString; aspect: aSymbol)! !

!ObjectSheet methodsFor: 'adding' stamp: 'HwaJong 3/4/2013 10:46'!
addRow: aString object: anObject 
	self rows addLast: (OSRow new name: aString; object: anObject)! !

!ObjectSheet methodsFor: 'adding' stamp: 'HwaJong 3/14/2013 18:41'!
addRowWithObject: anObject 
	self addRow: anObject printString object: anObject! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 18:09'!
cellObjectAtRow: anInteger atColumn: anInteger2 
	^(columns at: anInteger2) getAspectValueOf: (rows at: anInteger).! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:15'!
cellObjectAtRowName: string1 atColumnName: string2 
	^(self columnNamed: string2) aspect value: (self rowNamed: string1) object.! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:15'!
columnNamed: aString 
	^columns detect: [:each| each name = aString]! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:44'!
columns

	^columns setDefault: #defaultColumns for: self withSetter: #columns:! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:44'!
columns: anObject
		
	columns := anObject! !

!ObjectSheet methodsFor: 'defaults' stamp: 'HwaJong 3/4/2013 10:44'!
defaultColumns

	"Return a default object for instance variable columns."
	^OrderedCollection new! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 11:54'!
defaultName
	^'ObjectSheet'! !

!ObjectSheet methodsFor: 'defaults' stamp: 'HwaJong 3/4/2013 10:47'!
defaultRows

	"Return a default object for instance variable rows."
	^OrderedCollection new! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/14/2013 11:59'!
name
	^name setDefault: #defaultName for: self withSetter: #name:! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:41'!
name: aString 
	name := aString! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 4/2/2013 15:13'!
openMorphWithRowHeaders: aBoolean
	|morph|
	morph := ObjectSheetMorph new.
	morph treatsFirstColumnAsRowHeaderAspect: aBoolean.
	morph sheetModel: self.
	morph createThings.
	morph setExtentOfBigMorphs.
	^morph! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 3/14/2013 11:21'!
openWithRowHeaders
	^self openWithRowHeaders: true.! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 3/13/2013 22:07'!
openWithRowHeaders: aBoolean
	|morph|
	morph := ObjectSheetMorph new.
	morph treatsFirstColumnAsRowHeaderAspect: aBoolean.
	morph sheetModel: self.
	morph openInWindowLabeled: self name.
	morph createThings.
	morph extent: morph extent.
	^morph! !

!ObjectSheet methodsFor: 'display' stamp: 'HwaJong 3/13/2013 22:07'!
openWithoutRowHeaders
	^self openWithRowHeaders: false.! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/5/2013 11:12'!
rowNamed: aString 
	^rows detect: [:each| each name = aString]! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/4/2013 10:47'!
rows

	^rows setDefault: #defaultRows for: self withSetter: #rows:! !

!ObjectSheet methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 19:35'!
rows: aSequenceableCollection
		
	rows := aSequenceableCollection! !

Object subclass: #ObjectSheetPluggableMultiColumnListMorphModel
	instanceVariableNames: 'objectSheet selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morphic'!

!ObjectSheetPluggableMultiColumnListMorphModel methodsFor: 'defaults' stamp: 'HwaJong 3/13/2013 21:52'!
defaultSelectionIndex
	^0! !

!ObjectSheetPluggableMultiColumnListMorphModel methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 17:12'!
objectSheet
	^objectSheet! !

!ObjectSheetPluggableMultiColumnListMorphModel methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 17:12'!
objectSheet: anObjectSheet
	objectSheet := anObjectSheet! !

!ObjectSheetPluggableMultiColumnListMorphModel methodsFor: 'widget' stamp: 'HwaJong 3/13/2013 21:52'!
selectionIndex
	^selectionIndex setDefault: #defaultSelectionIndex for: self withSetter: #selectionIndex:! !

!ObjectSheetPluggableMultiColumnListMorphModel methodsFor: 'widget' stamp: 'HwaJong 3/13/2013 21:51'!
selectionIndex: anInteger 
	selectionIndex := anInteger.
	self changed: #selectionIndex! !

!ObjectSheetPluggableMultiColumnListMorphModel methodsFor: 'widget' stamp: 'HwaJong 3/13/2013 21:52'!
stringsForMutliColumnListMorph
	^objectSheet rows 
		collect: [:ro| 
			objectSheet columns asArray 
				collect: [:co| (co getAspectValueOf: ro) printString]]! !

!String methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 17:33'!
objectSheetCellMorphContents
	^self! !

!String methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 17:33'!
objectSheetCellMorphWidthIn: anObjectSheetMorph
	^(anObjectSheetMorph defaultCellFont widthOfStringOrText: self) + 20! !

!String methodsFor: '*ObjectSheet' stamp: 'HwaJong 4/2/2013 17:33'!
objectSheetCellMorphWithCellBounds: aRectangle  in:  anObjectSheetMorph
	^OSTextCellMorph new
		bounds: aRectangle;
		font: anObjectSheetMorph defaultCellFont;
		contents: self objectSheetCellMorphContents! !

ScrollPane subclass: #ObjectSheetMorph
	instanceVariableNames: 'waffle sheetModel bigMorph treatsFirstColumnAsRowHeaderAspect updateCellSelector updateMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectSheet-Morph'!

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 3/14/2013 12:36'!
booleanIconsWorkspace
|sh|
sh := ObjectSheet new.
sh name: 'boolean operations'.
sh addColumn: 'bool1' aspect: [:arr| arr at: 1].
sh addColumn: 'bool2' aspect: [:arr| arr at: 2].
sh addColumn: 'and' aspect: [:arr| (arr at: 1) and: [arr at: 2]].
sh addColumn: 'or' aspect: [:arr| (arr at: 1) or: [arr at: 2]].
sh addColumn: 'xor' aspect: [:arr| (arr at: 1) xor: [arr at: 2]].
{{false. false}. {false. true}. {true. false}. {true. true}} 
	do: [:m| sh addRow: m printString object: m].
sh openWithRowHeaders.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 3/14/2013 12:37'!
colorMorphWorkspace
|sh|
sh := ObjectSheet new.
sh addColumn: 'color' aspect: [:morph| Morph new color: morph color].
sh addColumn: 'width' aspect:  #width.
sh addColumn: 'height' aspect:  #height.
sh addColumn: 'area' aspect:  [:m| m width * m height].
(Morph allSubInstances shuffled first: 12) do: [:m| sh addRow: m printString object: m].
sh openWithRowHeaders.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 3/14/2013 19:15'!
errorWorkspace
|sh|
sh := ObjectSheet new.
sh name: 'exception handling'.
sh addColumn: 'sqrt' aspect: #sqrt.
sh addColumn: 'factorial' aspect: #factorial.
sh addColumn: 'size' aspect: #size.
sh addColumn: 'asUppercase' aspect: #asUppercase.
sh addRowWithObject: 4. 
sh addRowWithObject: 'hello buddy'.
sh openWithRowHeaders.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 3/14/2013 11:21'!
morphWorkspace
|sh|
sh := ObjectSheet new.
sh addColumn: 'color' aspect: #color.
sh addColumn: 'width' aspect:  #width.
sh addColumn: 'height' aspect:  #height.
sh addColumn: 'area' aspect:  [:m| m width * m height].
(Morph allSubInstances shuffled first: 12) do: [:m| sh addRow: m printString object: m].
sh openWithRowHeaders.! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 4/2/2013 12:17'!
multiColumnListMorphWorkspace
|sh mo li|
sh := ObjectSheet new.
sh name: 'boolean operations'.
sh addColumn: 'bool1' aspect: [:arr| arr at: 1].
sh addColumn: 'bool2' aspect: [:arr| arr at: 2].
sh addColumn: 'and' aspect: [:arr| (arr at: 1) and: [arr at: 2]].
sh addColumn: 'or' aspect: [:arr| (arr at: 1) or: [arr at: 2]].
sh addColumn: 'xor' aspect: [:arr| (arr at: 1) xor: [arr at: 2]].
{{false. false}. {false. true}. {true. false}. {true. true}} 
	do: [:m| sh addRow: m printString object: m].

mo := ObjectSheetPluggableMultiColumnListMorphModel new objectSheet: sh.

li := PluggableMultiColumnListMorph on: mo list: #stringsForMutliColumnListMorph selected: #selectionIndex changeSelected: #selectionIndex: menu: nil wrapSelector: #yourself.
li openInWindowLabeled: 'yes'! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 3/14/2013 11:22'!
salaryWorkspace
|dailyCharge constants os|
dailyCharge := ObjectSheet new
	name: 'daily charge';
	addColumn: 'unit price' aspect: #value;
	addRow: 'weekday' object: 23;
	addRow: 'sat, sun, holi' object: 25;
	addRow: 'event alpha' object: 30.


constants := ObjectSheet new
	name: 'constants';
	addColumn: 'value' aspect: #yourself;
	addRow: 'weeks per month' object: 4.


os := ObjectSheet new
	name: 'salary case study';
	addColumn: 'weekdays worked per week' aspect: [:arr| arr at: 1];
	addColumn: 'freedays worked per week' aspect: [:arr| arr at: 2];
	addColumn: 'events in month' aspect: [:arr| arr at: 3];
	addColumn: 'salary' aspect: [:arr| 
		((arr first * (dailyCharge cellObjectAtRowName: 'weekday' atColumnName: 'unit price')) +
		(arr second * (dailyCharge cellObjectAtRowName: 'sat, sun, holi' atColumnName: 'unit price'))) * (constants cellObjectAtRowName: 'weeks per month' atColumnName: 'value') +
		(arr third * (dailyCharge cellObjectAtRowName: 'event alpha' atColumnName: 'unit price'))];
	addRow: '2 weekdays per week' object: {2. 0. 0};
	addRow: '5 weekdays per week' object: {5. 0. 0};
	addRow: '2 weekdays per week + 1 event day' object: {2. 0. 1};
	addRow: '5 weekdays per week + 1 event day' object: {5. 0. 1};
	addRow: 'all month' object: {5. 2. 0};
	addRow: 'all month + 1 event day' object: {5. 2. 1}.

os openWithRowHeaders.
dailyCharge openWithRowHeaders.
constants openWithRowHeaders.

! !

!ObjectSheetMorph class methodsFor: 'examples' stamp: 'HwaJong 4/3/2013 03:58'!
testingWorkspace
|samples os|
samples := {true. World. 'hello'. Text string: 'red color text' attribute: TextColor red. Smalltalk}.

os := ObjectSheet new
	addColumn: 'object' aspect: [:each| each printString];
	addColumn: 'class' aspect: #class;
	addColumn: 'hash' aspect: #hash;
	addColumn: 'size' aspect: #size.
samples do: [:each| os addRowWithObject: each].

os openWithoutRowHeaders.! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/13/2013 21:42'!
addRowHeaderSegmentsToWaffle
	self treatsFirstColumnAsRowHeaderAspect
		ifTrue: 
			[waffle addFixedColumnSegment: self widthOfRowHeader.
			waffle addFixedColumnSegment: 1].! !

!ObjectSheetMorph methodsFor: 'self evaluating' stamp: 'HwaJong 3/14/2013 17:45'!
cellObjectOfColumnHeaderAtIndex: anInteger
	^(sheetModel columns at: anInteger) name asText allBold! !

!ObjectSheetMorph methodsFor: 'self evaluating' stamp: 'HwaJong 3/14/2013 17:28'!
cellObjectsOfColumnAtIndex: anInteger
	^(1 to: sheetModel rows size) collect: [ :rowIndex | sheetModel cellObjectAtRow: rowIndex atColumn: anInteger ]! !

!ObjectSheetMorph methodsFor: 'self evaluating' stamp: 'HwaJong 3/13/2013 21:43'!
columnOffsetByRowHeader
	^self treatsFirstColumnAsRowHeaderAspect
		ifTrue: [1]
		ifFalse: [0]! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/14/2013 00:11'!
createBigMorph
	|contentExtent|
	contentExtent := waffle columnSegments sumOfLengthOfFixedSegments @ waffle rowSegments sumOfLengthOfFixedSegments.
	bigMorph := Morph new extent: contentExtent; color: (Color gray: 0.8).
	waffle bounds: (0@0 extent: contentExtent).
	self scroller addMorph: bigMorph.
! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/14/2013 17:17'!
createCells
	(1 to: sheetModel rows size) do: [:rowIndex|
		(1 to: sheetModel columns size) do: [:columnIndex| 
			| cellObject |
			cellObject := sheetModel cellObjectAtRow: rowIndex atColumn: columnIndex.
			bigMorph addMorph: 
				(cellObject objectSheetCellMorphWithCellBounds: 
					(waffle boundsOfIndentationAtRow: rowIndex+1 atColumn: columnIndex+self columnOffsetByRowHeader) in: self)]].! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/14/2013 11:11'!
createColumnHeaders
	sheetModel columns keysAndValuesDo: [:key :column|
		bigMorph addMorph: 
			(OSHeaderCellMorph new
				font: self defaultCellFont;
				bounds: (waffle boundsOfIndentationAtRow: 1 atColumn: key+self columnOffsetByRowHeader);
				contents: column name)]! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/14/2013 11:10'!
createRowHeaders
	self treatsFirstColumnAsRowHeaderAspect
		ifTrue: 
			[sheetModel rows keysAndValuesDo: [:key :row|
				bigMorph addMorph: 
					(OSHeaderCellMorph new
						font: self defaultCellFont;
						bounds: (waffle boundsOfIndentationAtRow: key+1 atColumn: 1);
						contents: row name)]]! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/13/2013 21:34'!
createThings
	self createWaffle.
	self createBigMorph.
	self createCells.
	self createRowHeaders.
	self createColumnHeaders.! !

!ObjectSheetMorph methodsFor: 'create morphs' stamp: 'HwaJong 3/13/2013 21:37'!
createWaffle
	waffle := WFWaffleLayout new.
	waffle addFixedColumnSegment: 2.
	self addRowHeaderSegmentsToWaffle.
	(1 to: sheetModel columns size) 
		do: [:key|
			waffle addFixedColumnSegment: (self widthOfColumnAtIndex: key)] 
		separatedBy: [waffle addFixedColumnSegment: 1].	
	waffle addFixedColumnSegment: 2.

	waffle addFixedRowSegment: 2.
	waffle addFixedRowSegment: self heightOfColumnHeader.
	waffle addFixedRowSegment: 1.
	(1 to: sheetModel rows size) 
		do: [:key|
			waffle addFixedRowSegment: (self heightOfRowAtIndex: key)]
		separatedBy: [waffle addFixedRowSegment: 1].
	waffle addFixedRowSegment: 2.! !

!ObjectSheetMorph methodsFor: 'fonts' stamp: 'HwaJong 3/14/2013 00:05'!
defaultCellFont
	^StandardFonts defaultFont! !

!ObjectSheetMorph methodsFor: 'defaults' stamp: 'HwaJong 3/13/2013 21:47'!
defaultTreatsFirstColumnAsRowHeaderAspect
	^true! !

!ObjectSheetMorph methodsFor: 'defaults' stamp: 'HwaJong 4/2/2013 15:46'!
defaultUpdateMethod
	^OSNullUpdate newForObjectSheetMorph: sheetModel! !

!ObjectSheetMorph methodsFor: 'geo1 - height' stamp: 'HwaJong 3/13/2013 21:29'!
heightOfColumnHeader
	^25! !

!ObjectSheetMorph methodsFor: 'geo1 - height' stamp: 'HwaJong 3/13/2013 21:29'!
heightOfRowAtIndex: anInteger
	^25! !

!ObjectSheetMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2013 15:20'!
setExtentOfBigMorphs
	self extent: bigMorph extent + 10! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:57'!
sheetModel
	^sheetModel! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 21:29'!
sheetModel: anObjectSheet
	sheetModel := anObjectSheet! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 21:46'!
treatsFirstColumnAsRowHeaderAspect
	^treatsFirstColumnAsRowHeaderAspect setDefault: #defaultTreatsFirstColumnAsRowHeaderAspect for: self withSetter: #treatsFirstColumnAsRowHeaderAspect:! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 3/13/2013 21:46'!
treatsFirstColumnAsRowHeaderAspect: aBoolean
	treatsFirstColumnAsRowHeaderAspect := aBoolean! !

!ObjectSheetMorph methodsFor: 'updating' stamp: 'HwaJong 4/2/2013 17:15'!
update: aSymbol
	self updateMethod updateObjectSheetMorphBy: aSymbol! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:25'!
updateCellSelector
	^updateCellSelector! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:25'!
updateCellSelector: aSymbol
	updateCellSelector := aSymbol! !

!ObjectSheetMorph methodsFor: 'updating' stamp: 'HwaJong 4/3/2013 03:29'!
updateCells
	bigMorph delete.
	self createThings.! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:40'!
updateMethod
	^ updateMethod setDefault: #defaultUpdateMethod for: self withSetter: #updateMethod:! !

!ObjectSheetMorph methodsFor: 'accessing' stamp: 'HwaJong 4/2/2013 15:39'!
updateMethod: anOSUpdatingMethod
	updateMethod := anOSUpdatingMethod! !

!ObjectSheetMorph methodsFor: 'geo1 - width' stamp: 'HwaJong 3/14/2013 17:45'!
widthOfColumnAtIndex: anInteger
	|cellWidths headerWidth|
	cellWidths := 
		(self cellObjectsOfColumnAtIndex: anInteger)
			collect: [ :object |  object objectSheetCellMorphWidthIn: self ].

	headerWidth := (self cellObjectOfColumnHeaderAtIndex: anInteger) objectSheetCellMorphWidthIn: self.

	^(cellWidths , {headerWidth}) max max: 50.! !

!ObjectSheetMorph methodsFor: 'geo1 - width' stamp: 'HwaJong 3/14/2013 00:58'!
widthOfRowHeader
	^(sheetModel rows collect: [:each| self defaultCellFont widthOfStringOrText: each name asText allBold]) max + 20! !
